#ifndef BUTTON_H_INCLUDED
#define BUTTON_H_INCLUDED
#include "unicore-mx/stm32/gpio.h"

static const uint32_t Channel[5] = { 8, 9, 7, 6, 5 };
static const uint32_t Channel_Pin[5] = { GPIO8, GPIO9, GPIO7, GPIO6, GPIO5 };
static const char Channel_name[5][16] = { "Red", "Purple", "Green", "Blue", "Yellow" };


void button_init(void);
int button_poll(void (*callback)(uint8_t press, int hold));
int input_get_swr(void);

#define N_BUTTONS 2 

#endif
